<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ProposalModelService;
use SM\Traits\TResponse;

class ProposalModelController extends SMCrud
{
    use TResponse;

    protected $ProposalModelService;

    public function __construct($crudService, $environment, ProposalModelService $ProposalModelService)
    {
        parent::__construct($crudService, $environment);
        $this->ProposalModelService = $ProposalModelService;
    }

    public function getProposalModel(Request $request) //ok
    {
        try {
            $data = $this->ProposalModelService->getProposalModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabEscopoFaturamentoProposal(Request $request) //ok
    {
        try {
            $data = $this->ProposalModelService->getTabEscopoFaturamentoProposal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabComposicoes(Request $request) //ok
    {
        try {
            $data = $this->ProposalModelService->getTabComposicoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabItens(Request $request) //ok
    {
        try {
            $data = $this->ProposalModelService->getTabItens($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabPerfisAcessoProposal(Request $request)
    {
        try {
            $data = $this->ProposalModelService->getTabPerfisAcessoProposal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabSignatariosPadroesProposal(Request $request)
    {
        try {
            $data = $this->ProposalModelService->getTabSignatariosPadroesProposal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getServicoProduto(Request $request)
    {
        try {
            $data = $this->ProposalModelService->getServicoProduto($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTipoMedidaProposal(Request $request)
    {
        try {
            $data = $this->ProposalModelService->getTipoMedidaProposal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddProposalModel(Request $request)
    {
        try {
            $data = $this->ProposalModelService->saveModalAddProposalModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteProposalModel(Request $request)
    {
        try {
            $data = $this->ProposalModelService->deleteProposalModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteProposalModelTabEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->ProposalModelService->deleteProposalModelTabEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteProposalModelTabComposicoes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->deleteProposalModelTabComposicoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteProposalModelTabPerfisAcesso(Request $request)
    {
        try {
            $data = $this->ProposalModelService->deleteProposalModelTabPerfisAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteProposalModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->deleteProposalModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getEscopoDeFaturamentoProposal()
    {
        try {
            $data = $this->ProposalModelService->getEscopoDeFaturamentoProposal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getModeloContratoProposal()
    {
        try {
            $data = $this->ProposalModelService->getModeloContratoProposal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddProposalModelTabEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->ProposalModelService->saveModalAddProposalModelTabEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddProposalModelTabComposicoes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->saveModalAddProposalModelTabComposicoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddProposalModelTabPerfisAcesso(Request $request)
    {
        try {
            $data = $this->ProposalModelService->saveModalAddProposalModelTabPerfisAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddProposalModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->saveModalAddProposalModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getComposicoes()
    {
        try {
            $data = $this->ProposalModelService->getComposicoes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTipoDocCertsign()
    {
        try {
            $data = $this->ProposalModelService->getTipoDocCertsign();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getPerfisDeAcessoProposal()
    {
        try {
            $data = $this->ProposalModelService->getPerfisDeAcessoProposal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getSignatariosProposalModel()
    {
        try {
            $data = $this->ProposalModelService->getSignatariosProposalModel();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getOperadoresProposalModel()
    {
        try {
            $data = $this->ProposalModelService->getOperadoresProposalModel();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getCpfSignatario(Request $request)
    {
        try {
            $data = $this->ProposalModelService->getCpfSignatario($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editProposalModelTabComposicoes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->editProposalModelTabComposicoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editProposalModelViewItens(Request $request)
    {
        try {
            $data = $this->ProposalModelService->editProposalModelViewItens($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editProposalModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ProposalModelService->editProposalModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editProposalModel(Request $request)
    {
        try {
            $data = $this->ProposalModelService->editProposalModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
}