<?php

namespace SM\Controller;

use SM\Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00005000TabParametrizacoesServicesService;
use SM\Traits\TResponse;

class Sm00005000TabParametrizacoesServicesController
{
    use TResponse;

    protected $parametrizacaoService;

    public function __construct(Sm00005000TabParametrizacoesServicesService $parametrizacaoService)
    {
        $this->parametrizacaoService = $parametrizacaoService;
    }

    public function getParametrosGeral()
    {
        try {
            $data = $this->parametrizacaoService->getParametrosGeral();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getNomePerfAcess()
    {
        try {
            $data = $this->parametrizacaoService->getNomePerfAcess();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function buscaNovoCodigo(Request $request)
    {
        try {
            $data = $this->parametrizacaoService->buscaNovoCodigo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function atualizaNovoCodigo(Request $request)
    {
        try {
            $data = $this->parametrizacaoService->atualizaNovoCodigo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insereNovoCodigo(Request $request)
    {
        try {
            $data = $this->parametrizacaoService->insereNovoCodigo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveperfilacesso(Request $request)
    {
        try {
            $data = $this->parametrizacaoService->saveperfilacesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveDadosParametrosService(Request $request)
    {
        try {
            $data = $this->parametrizacaoService->saveDadosParametrosService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
