<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CdaFactory
{
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCda($params)
    {
        $sql = "SELECT DATA.CDEMPRESA || '-' || DATA.CDFUNC || '-' || SERV.CDCLIENTE || '-' || SERV.NRSERVPREST || '-' || TO_CHAR(NVL(SERV.DTSERVPREST, DATA.DTDATA), 'DD/MM/YYYY') AS CODIGO,
                       SERV.CDFILIAL,
                       TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY') AS DATA,
                       DECODE(FERI.DTFERIFILI, NULL, 'S', 'N') AS IDDIAUTIL,
                       TO_CHAR(NVL(SERV.DTSERVPREST, DATA.DTDATA), 'DD/MM/YYYY') DTSERVPREST,
                       DATA.NMFUNC,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NMRAZSOCCLIE ELSE PROS.NMRAZSOCPROS END AS NMCLIEPROSP,
                       INTC.CDINTECLIE,
                       INTP.CDINTEPROS,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.NRTEL1INCLIE ELSE INTP.NRTEL1INPROS END AS NRTELINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.DSEMAILICLIE ELSE INTP.DSEMAILIPROS END AS DSEMAILINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NRPARCNEGOCIO ELSE PROS.NRPARCNEGOCIO END AS NRPARCNEGOCIO,
                       CASE SERV.IDSERVPREST WHEN 'VISITA_PROSPECT' THEN PROS.NMRAZSOCPROS || ' - ' || PROS.NMFANTPROS 
                                             WHEN 'RELACIONAMENTO_CLIENTE' THEN CLIE.NMRAZSOCCLIE || ' - ' || CLIE.NMFANTCLIE 
                                             WHEN 'ATIVIDADE_CLIENTE' THEN CLIE.NMRAZSOCCLIE || ' - ' || CLIE.NMFANTCLIE 
                       ELSE NULL END AS  NMFANTRAZ,
                       CLIE.NMFANTCLIE,
                       CLIE.NMRAZSOCCLIE,
                       PROS.NMFANTPROS,
                       PROS.NMRAZSOCPROS,
                       NVL(SERV.DSREFERENCIA, 'CDA - '||TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY')) AS DSREFERENCIA,
                       DATA.CDEMPRESA,
                       DATA.CDFUNC,
                       SERV.CDCLIENTE,
                       PROS.CDPROSPECT,
                       SERV.NRORG,
                       SERV.NMINTCLIENTE,
                       SERV.NRLICENCAUSO,
                       LUSO.NMFANTLUSO,
                       CLIE.NRINSJURCLIE,
                       SERV.NRSERVCONT,
                       SERV.NRSEQEVOLCONT,
                       SERV.NRSEQAGESERV,
                       SERV.CDTIPOSERV,
                       TPSV.NMTIPOSERV,
                       SERV.IDSERVPREST AS IDSERVPREST_IN_GRID,
                       SERV.IDSERVPREST,
                       TO_CHAR(SERV.DTENTRADA, 'HH24:MI') AS DTENTRADA,
                       TO_CHAR(SERV.DTSAIDA, 'HH24:MI') AS DTSAIDA,
                       SERV.HRAUSENCIAALMOCO,
                       SERV.QTHRDESLOCAMENTOFAT,
                       SERV.QTHRATIVIDADEFAT,
                       DECODE(SERV.IDSERVPREST, 'FALTA_NAO_JUSTIFICADA', 'S', 'N') AS IDFALTA,
                       SERV.NRPROPOSFAS,
                       SERV.NRVERPROPFAS,
                       SERV.NRSEQUCHT,
                       SERV.DSJUSTHRNAOFATURADA,
                       NVL(SERV.IDSITSERVPREST,'P') AS IDSITSERVPREST,
                       PRO.CDPROJETO,
                       PRO.NMPROJETO,
                       NVL(SERV.NRSERVPREST, '00000') AS NRSERVPREST,
                       SERV.NRMOTIVOEXCEFREQ,
                       DECODE(PROP.NRPROPOSFAS, NULL, NULL, PROP.NRPROPOSFAS||'-'||PROP.NRVERPROPFAS) AS NR_VER_PROP,
                       PROP.DSREFEPROPOSFAS,
                       DATA.CDOPERADOR,
                       INTC.NMINTECLIE,
                       INTP.NMINTEPROS,
                       CONT.NRSEQCONTATO AS NRCONTATO,
                       CONT.DSREFECONT,
                       CONT.CDMOTICONT,
                       CONT.CDSISTEMA,
                       MOTC.NMMOTICONT,
                       EVOC.CDMOTIEVOCON,
                       MEVC.NMMOTIEVOCON,
                       EVOC.DSEVOLCONT,
                       EVOC.DTHREVOLCONT,
                       DECODE(DSSP.NRSERVPREST, NULL, 'N', 'S') AS IDDESCRICAOOK,
                       'S' AS IDATIVO,
                       PER.PERMISSAO,
                       DECODE(SERV.IDSERVPREST, NULL, 'N', 'S') AS IDEXISTSCDA,
                       CASE WHEN TRUNC(SYSDATE) - TRUNC(DATA.DTDATA) > 7
                            THEN 'S'
                            ELSE 'N' END AS IDLIMITEDIAS
                      FROM (SELECT :CDFILIAL AS CDFILIAL, FUNC.CDFILIALOCFUNC, FUNC.NRORG, FUNC.CDEMPRESA,  FUNC.CDFUNC, FUNC.NMFUNC, OPER.CDOPERADOR, DATA.DTDATA
                              FROM DATA, FUNCIONARIO FUNC, OPERADOR OPER
                             WHERE DATA.DTDATA BETWEEN TO_DATE(:DTINICIALPERIODO, 'DD/MM/YYYY') AND TO_DATE(:DTFINALPERIODO, 'DD/MM/YYYY')
                               AND FUNC.CDEMPRESA = :CDEMPRESA
                               AND FUNC.CDFUNC = :CDFUNC
                               AND FUNC.NRORG = :NRORG
                               AND FUNC.NRORG = OPER.NRORG
                               AND FUNC.CDEMPRESA = OPER.CDEMPRESA
                               AND FUNC.CDFUNC = OPER.CDFUNC) DATA,
                           SERVPREST SERV, CLIENTE CLIE, PROJETO PRO, FERIFILI FERI, PROSPECT PROS, LICENCAUSO LUSO, PROPOSTAFAS PROP, 
                           TIPOSERV TPSV, INTECLIE INTC, INTEPROSP INTP, CONTATO CONT, EVOLCONT EVOC, MOTICONT MOTC, MOTIEVOLCONT MEVC,
                           DESCSERVPRES DSSP,
                           (SELECT COUNT(*) AS PERMISSAO
                              FROM AUTGRUPOP
                             WHERE (IDAUTGRUPOP = 'DPAP' OR IDAUTGRUPOP = 'ACSA')
                               AND CDGRUPOPER IN (SELECT CDGRUPOPER
                                                    FROM OPERGRUPOP
                                                   WHERE CDOPERADOR = :CDOPERADOR)) PER
                     WHERE DATA.NRORG = SERV.NRORG(+)
                       AND DATA.CDEMPRESA = SERV.CDEMPRESA(+)
                       AND DATA.CDFUNC = SERV.CDFUNC(+)
                       AND DATA.DTDATA = SERV.DTSERVPREST(+)
                       AND DATA.NRORG = FERI.NRORG(+)
                       AND DATA.CDFILIALOCFUNC = FERI.CDFILIAL(+)
                       AND DATA.DTDATA = FERI.DTFERIFILI(+)
                       AND SERV.NRORG = CLIE.NRORG(+)
                       AND SERV.CDCLIENTE = CLIE.CDCLIENTE(+)
                       AND SERV.NRORG = PRO.NRORG(+)
                       AND SERV.CDPROJETO = PRO.CDPROJETO(+)
                       AND SERV.NRORG = PROS.NRORG(+)
                       AND SERV.CDPROSPECT = PROS.CDPROSPECT(+)
                       AND SERV.NRORG = LUSO.NRORG(+)
                       AND SERV.CDCLIENTE = LUSO.CDCLIENTE(+)
                       AND SERV.NRLICENCAUSO = LUSO.NRLICENCAUSO(+)
                       AND SERV.NRORG = PROP.NRORG(+)
                       AND SERV.NRPROPOSFAS = PROP.NRPROPOSFAS(+)
                       AND SERV.NRVERPROPFAS = PROP.NRVERPROPFAS(+)
                       AND SERV.NRORG = TPSV.NRORG(+)
                       AND SERV.CDTIPOSERV = TPSV.CDTIPOSERV(+)
                       AND SERV.NRORG = INTC.NRORG(+)
                       AND SERV.CDCLIENTE = INTC.CDCLIENTE(+)
                       AND SERV.CDINTECLIE = INTC.CDINTECLIE(+)
                       AND SERV.NRORG = INTP.NRORG(+)
                       AND SERV.CDPROSPECT = INTP.CDPROSPECT(+)
                       AND SERV.CDINTEPROS = INTP.CDINTEPROS(+)
                       AND SERV.NRORG = CONT.NRORG(+)
                       AND SERV.NRCONTATO = CONT.NRSEQCONTATO(+)
                       AND SERV.NRORG = EVOC.NRORG(+)
                       AND SERV.NRCONTATO = EVOC.NRSEQCONTATO(+)
                       AND SERV.DTHREVOLCONT = EVOC.DTHREVOLCONT(+)
                       AND SERV.CDEMPRESA = DSSP.CDEMPRESA(+)
                       AND SERV.CDFUNC = DSSP.CDFUNC(+)
                       AND SERV.CDCLIENTE = DSSP.CDCLIENTE(+)
                       AND SERV.DTSERVPREST = DSSP.DTSERVPREST(+)
                       AND SERV.NRSERVPREST = DSSP.NRSERVPREST(+)
                       AND SERV.NRORG = DSSP.NRORG(+)
                       AND CONT.NRORG = MOTC.NRORG(+)
                       AND CONT.CDMOTICONT = MOTC.CDMOTICONT(+)
                       AND EVOC.NRORG = MEVC.NRORG(+)
                       AND EVOC.CDMOTIEVOCON = MEVC.CDMOTIEVOCON(+)
                       AND :CDFUNC = :CDFUNC
                    ORDER BY TO_DATE(DATA, 'DD/MM/YYYY'), SERV.NRSERVPREST";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getFuncionarios()
    {
        
        $sql = "SELECT OPER.CDOPERADOR, OPER.NMOPERADOR, FUNC.CDFUNC, FUNC.NRORG, FUNC.CDEMPRESA, FUNC.CDFILIAL, 
                FUNC.CDTPADMISSAO, FUNC.CDFUNC || ' - ' || OPER.NMOPERADOR AS DISPLAYFUNC
                FROM FUNCIONARIO FUNC, OPERADOR OPER
                WHERE FUNC.CDFUNC = OPER.CDFUNC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPermissaoOperadorCda($parametros)
    {
        $sql = "SELECT OPG.CDGRUPOPER, AUT.IDAUTGRUPOP, OPG.CDOPERADOR
                    FROM OPERGRUPOP OPG, AUTGRUPOP AUT
                    WHERE OPG.CDGRUPOPER = AUT.CDGRUPOPER
                    AND OPG.CDOPERADOR = :CDOPERADOR
                    AND OPG.NRORG = :NRORG";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getPeriodoApuraPonto()
    {
        $sql = "SELECT DISTINCT
                    F.DTINICIALAPURAPONTO,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ' - ' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') || DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', ' (Período aberto)', ' (Período fechado)') DISPLAY,
                    DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', '(Em aberto)', '(Fechado)') STATUS,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ',' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') VALUE
                FROM 
                    FPA_PERIODOAPURAPONTO F
                WHERE 
                    F.DTINICIALAPURAPONTO <= TRUNC(SYSDATE)
                ORDER BY 
                    F.DTINICIALAPURAPONTO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getClienteCda($parametros)
    {
        $sql = "SELECT DISTINCT CLIENTE.CDCLIENTE, CLIENTE.NMRAZSOCCLIE, CLIENTE.NMFANTCLIE, CLIENTE.NRINSJURCLIE, CLIENTE.NRORG, CLIENTE.NRPARCNEGOCIO,
                AGENDASERV.DTINITRASERV, AGENDASERV.DTFINTRASERV
                    FROM CLIENTE
                    JOIN PROPOSTAFAS
                    ON PROPOSTAFAS.CDCLIENTE = CLIENTE.CDCLIENTE
                    JOIN AGENDASERV 
                    ON AGENDASERV.NRPROPOSFAS = PROPOSTAFAS.NRPROPOSFAS
                    AND AGENDASERV.NRVERPROPFAS = PROPOSTAFAS.NRVERPROPFAS
                    WHERE AGENDASERV.CDFUNC = :CDFUNC             
                    AND (TRUNC(TO_DATE(:DTSERVPREST, 'DD/MM/YYYY')) BETWEEN TRUNC(AGENDASERV.DTINITRASERV) AND TRUNC(AGENDASERV.DTFINTRASERV))
                    AND CLIENTE.IDCLIEATIV = 'S'
                    ORDER BY NMRAZSOCCLIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getClienteRelacionamento()
    {
        $sql = "SELECT CLIENTE.CDCLIENTE, CLIENTE.NMRAZSOCCLIE, CLIENTE.NMFANTCLIE, CLIENTE.NRINSJURCLIE, CLIENTE.NRORG, CLIENTE.NRPARCNEGOCIO, CLIENTE.IDCLIEATIV
                    FROM CLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getInterlocutorClienteCda($params)
    {
        $sql = "SELECT
                    INTECLIE.CDINTECLIE,
                    INTECLIE.NMINTECLIE,
                    INTECLIE.NRORG,
                    INTECLIE.CDCLIENTE,
                    INTECLIE.DSEMAILICLIE,
                    INTECLIE.NRFAXINCLIE ,
                    INTECLIE.NRTEL1INCLIE
                FROM
                    INTECLIE WHERE CDCLIENTE = :CDCLIENTE ORDER BY CDINTECLIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getInterlocutorProspectCda($params)
    {
        $sql = "SELECT
                    INTEPROSP.CDINTEPROS, INTEPROSP.NMINTEPROS, INTEPROSP.NRORG, INTEPROSP.CDPROSPECT, INTEPROSP.NRTEL1INPROS, INTEPROSP.DSEMAILIPROS,
                    INTEPROSP.CDINTEPROS || ' - ' || INTEPROSP.NMINTEPROS AS DISPLAYINTPROSPECT
                FROM INTEPROSP 
                WHERE CDPROSPECT = :CDPROSPECT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function atualizarInfoInterlocutorProspect($parametros)
    {
        $sql = "UPDATE INTEPROSP
                    SET NRTEL1INPROS = :NRTEL1INPROS,
                        DSEMAILIPROS = :DSEMAILIPROS
                        WHERE CDPROSPECT = :CDPROSPECT";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarInfoInterlocutorCliente($parametros)
    {
        $sql = "UPDATE INTECLIE
                    SET NRTEL1INCLIE = :NRTEL1INCLIE,
                        DSEMAILICLIE = :DSEMAILICLIE
                        WHERE CDINTECLIE = :CDINTECLIE";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function getPropostaCda($params)
    {
        $sql = "SELECT DISTINCT
                    A.NRPROPOSFAS || '-'|| A.NRVERPROPFAS AS NR_VER_PROP,
                    A.NRPROPOSFAS,
                    A.NRVERPROPFAS,
                    P.DSREFEPROPOSFAS,
                    A.NRORG,
                    A.CDFUNC,
                    C.CDCLIENTE,
                    A.NRPROPOSFAS || '-'|| A.NRVERPROPFAS || ' - ' || P.DSREFEPROPOSFAS AS DISPLAYPROPOSTA,
                    A.NRSERVCONT, A.NRSEQAGESERV
                FROM
                    CLIENTE      C,
                    CONTRATOSERV CO,
                    AGENDASERV   A,
                    PROPOSTAFAS  P
                WHERE
                        A.NRORG = CO.NRORG
                    AND A.NRPROPOSFAS = CO.NRPROPOSFAS
                    AND A.NRVERPROPFAS = CO.NRVERPROPFAS
                    AND A.CDTIPOSERV = CO.CDTIPOSERV
                    AND A.NRSERVCONT = CO.NRSERVCONT
                    AND C.NRORG = CO.NRORG
                    AND C.CDCLIENTE = CO.CDCLIENTE
                    AND A.NRORG = P.NRORG
                    AND A.NRPROPOSFAS = P.NRPROPOSFAS
                    AND A.NRVERPROPFAS = P.NRVERPROPFAS
                    AND A.NRORG = :NRORG
                    AND A.CDFUNC = :CDFUNC
                    AND C.CDCLIENTE = :CDCLIENTE
                ORDER BY
                    A.NRPROPOSFAS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getProjetoOperadorCliente($params)
    {
        $sql = "SELECT CDPROJETO, NMPROJETO
                FROM (SELECT MAX(C.CDVERCRONPRJ) AS CDCRONO, P.NRORG, P.CDCLIENTE, C.CDOPERADOR,
                                C.CDNIVELITPRJ AS NIVEL, P.CDPROJETO, P.NMPROJETO
                        FROM PROJETO P, CRONOPROJETO C
                    WHERE P.NRORG = C.NRORG
                        AND P.CDFILIAL = C.CDFILIAL
                        AND P.CDPROJETO = C.CDPROJETO
                        AND C.CDOPERADOR = :CDOPERADOR
                        AND P.CDCLIENTE = :CDCLIENTE
                        AND P.NRORG = :NRORG
                        AND CDNIVELITPRJ = '3'
                    GROUP BY P.NRORG, P.CDCLIENTE, C.CDOPERADOR,P.CDPROJETO, C.CDNIVELITPRJ, C.CDOPERADOR, P.NMPROJETO
                    ORDER BY C.CDNIVELITPRJ DESC
                    ) PROJETO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTipoAtividadeCda($parametros)
    {
        $sql = "SELECT TIPOSERV.NMTIPOSERV, TIPOSERV.CDTIPOSERV, CONTRATOSERV.CDCLIENTE, CONTRATOSERV.NRPROPOSFAS, CONTRATOSERV.NRVERPROPFAS, 
                            CONTRATOSERV.NRSERVCONT, CONTRATOSERV.QTSERVCONT, AGENDASERV.NRORG, AGENDASERV.CDFUNC
                            FROM TIPOSERV 
                            JOIN CONTRATOSERV
                            ON CONTRATOSERV.CDTIPOSERV = TIPOSERV.CDTIPOSERV
                            AND CONTRATOSERV.NRORG = TIPOSERV.NRORG
                            JOIN AGENDASERV
                            ON AGENDASERV.CDTIPOSERV = TIPOSERV.CDTIPOSERV
                            AND AGENDASERV.NRORG = CONTRATOSERV.NRORG
                            AND AGENDASERV.NRVERPROPFAS = CONTRATOSERV.NRVERPROPFAS
                            AND AGENDASERV.CDTIPOSERV = CONTRATOSERV.CDTIPOSERV
                            AND AGENDASERV.NRSERVCONT = CONTRATOSERV.NRSERVCONT
                            AND AGENDASERV.NRPROPOSFAS = CONTRATOSERV.NRPROPOSFAS
                            WHERE CONTRATOSERV.NRPROPOSFAS = :NRPROPOSFAS
                            AND CONTRATOSERV.NRVERPROPFAS = :NRVERPROPFAS
                            AND CONTRATOSERV.CDCLIENTE = :CDCLIENTE
                            AND CONTRATOSERV.NRORG = :NRORG
                            AND AGENDASERV.CDFUNC = :CDFUNC
                            AND (TO_DATE(:DTSERVPREST, 'DD/MM/YYYY') BETWEEN DTINITRASERV AND DTFINTRASERV)
                            ORDER BY TIPOSERV.CDTIPOSERV";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getProspectCda()
    {
        $sql = "SELECT PROSPECT.NRINSJURPROS, PROSPECT.NMRAZSOCPROS, PROSPECT.NRORG, PROSPECT.CDPROSPECT, PROSPECT.NRPARCNEGOCIO,
                        PROSPECT.CDPROSPECT  || ' - ' || PROSPECT.NMRAZSOCPROS AS DISPLAYPROSPECT
                FROM PROSPECT 
                ORDER BY NMRAZSOCPROS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLicencaUsoCda($params)
    {
        $sql = "SELECT LICENCAUSO.CDCLIENTE, LICENCAUSO.NRLICENCAUSO, LICENCAUSO.NRORG, LICENCAUSO.CDLOCALUSO, LICENCAUSO.NMFANTLUSO, LICENCAUSO.NMRAZSOCLUSO,
                        LICENCAUSO.CDLOCALUSO || ' - ' || LICENCAUSO.NMFANTLUSO AS DISPLAYLICENSAUSO
                FROM LICENCAUSO
                WHERE LICENCAUSO.CDCLIENTE = :CDCLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getContatosParceiroCda($params)
    {
        $sql = "SELECT CONTATO.NRSEQCONTATO, CONTATO.DSREFECONT, CONTATO.CDOPERCONT, CONTATO.NRPARCNEGOCIO, 
                        CONTATO.CDMOTICONT, CONTATO.DTHRCONTATO, CONTATO.NRORG, CONTATO.CDFILIAL, CONTATO.IDATIVO, PARC.NMPRINCIPALPARC,
                        CONTATO.NRSEQCONTATO || ' - ' || CONTATO.DSREFECONT AS DISPLAYCONTATO
                FROM CONTATO
                INNER JOIN PARCNEGOCIO PARC ON PARC.NRPARCNEGOCIO = CONTATO.NRPARCNEGOCIO
                AND PARC.NRORG = CONTATO.NRORG
                AND CONTATO.NRPARCNEGOCIO = :NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getContatoCda($parametros)
    {
        $sql = "SELECT NRSEQCONTATO, DSREFECONT, CDOPERCONT, NRPARCNEGOCIO, CDMOTICONT, IDSTATUSCONT, IDTPCONTATO,
                        DTHRCONTATO, NRORG, CDFILIAL, IDATIVO
                FROM CONTATO
                WHERE NRSEQCONTATO = :NRSEQCONTATO";
        
        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0];
    }

    public function getEvoltcontCda($parametros)
    {
        $sql = "SELECT NRSEQCONTATO, DTHREVOLCONT, NRSEQEVOLCONT
                FROM EVOLCONT
                WHERE NRSEQCONTATO = :NRSEQCONTATO
                AND NRSEQEVOLCONT = :NRSEQEVOLCONT";

        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        if (count($retorno) > 0) {
            return $retorno[0];
        }
        return null;
    }

    public function getMotivoEvoContCda()
    {
        $sql = "SELECT
                    MOTIEVOLCONT.CDMOTIEVOCON,
                    MOTIEVOLCONT.NMMOTIEVOCON,
                    MOTIEVOLCONT.NRORG,
                    MOTIEVOLCONT.CDMOTIEVOCON || ' - ' || MOTIEVOLCONT.NMMOTIEVOCON AS DISPLAYMOTIVOEVOCONT
                FROM
                    MOTIEVOLCONT ORDER BY CDMOTIEVOCON";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMotivoContatoCda()
    {
        $sql = "SELECT CDMOTICONT, NMMOTICONT
                    FROM MOTICONT 
                    WHERE IDATIVO = 'S'
                    ORDER BY NMMOTICONT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getSistemaCda()
    {
        $sql = "SELECT CDSISTEMA AS CDSISTEMA, NMSISTEMA AS NMSISTEMA, IDTECNOSIST
                FROM SISTEMA
                WHERE IDTECNOSIST = 'WEB'
                ORDER BY NMSISTEMA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getNrrelacionaparcProspect($parametros)
    {
        $sql = "SELECT CDINTEPROS, NMINTEPROS, NRORG, CDPROSPECT, NRRELACIONAPARC
                FROM INTEPROSP
                WHERE CDPROSPECT = :CDPROSPECT
                AND CDINTEPROS = :CDINTEPROS
                AND NRORG = :NRORG";

        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0];
    }

    public function getNrrelacionaparcCliente($parametros)
    {
        $sql = "SELECT CDINTECLIE, NMINTECLIE, NRORG, CDCLIENTE, NRRELACIONAPARC
                FROM INTECLIE
                WHERE CDCLIENTE = :CDCLIENTE
                AND CDINTECLIE = :CDINTECLIE
                AND NRORG = :NRORG";

        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0];
    }

    public function consultaProxSequencialEvolCont($parametros)
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(EVC.NRSEQEVOLCON)), 0)+1, '09')) AS NRSEQEVOLCON
                    FROM EVOLCONT EVC WHERE EVC.NRORG = :NRORG
                                        AND EVC.NRSEQCONTATO = :NRCONTATO";
            
        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0]['NRSEQEVOLCON'];
    }

    public function consultaProxNrServPrest($parametros)
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(SP.NRSERVPREST)), 0)+1, '00000')) AS NRSERVPREST
                    FROM SERVPREST SP 
                    WHERE SP.NRORG = :NRORG
                    AND SP.CDEMPRESA = :CDEMPRESA
                    AND SP.CDFUNC = :CDFUNC
                    AND SP.CDCLIENTE = :CDCLIENTE
                    AND SP.DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY HH24:MI:SS')";
            
        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0]['NRSERVPREST'];
    }

    public function inserirContatoCda($parametros)
    {
        $sql = "INSERT INTO CONTATO ( NRCONTATO, CDMOTICONT, CDCLIENTE, CDPROSPECT, DTHRCONTATO, DSREFECONT, IDSTATUSCONT, IDTPCONTATO, CDSISTEMA, CDOPERCONT, NRORG, NRORGINCLUSAO, NRORGULTATU, DTINCLUSAO, CDOPERINCLUSAO, NRPARCNEGOCIO, NRSEQCONTATO) 
        VALUES ( :NRCONTATO, :CDMOTICONT, :CDCLIENTE, :CDPROSPECT, :DTHRCONTATO, :DSREFECONT, :IDSTATUSCONT, :IDTPCONTATO, :CDSISTEMA, :CDOPERCONT, :NRORG, :NRORGINCLUSAO, :NRORGULTATU, SYSDATE, :CDOPERINCLUSAO, :NRPARCNEGOCIO, :NRSEQCONTATO)";
        $this->connection->executeStatement($sql, $parametros);
    }
    
    public function atualizarContatoCda($parametros)
    {
        $sql = "UPDATE CONTATO
                    SET NRCONTATO = :NRCONTATO,
                        CDMOTICONT = :CDMOTICONT,
                        CDCLIENTE = :CDCLIENTE,
                        CDPROSPECT = :CDPROSPECT,
                        DSREFECONT = :DSREFECONT,
                        IDTPCONTATO = :IDTPCONTATO,
                        CDSISTEMA = :CDSISTEMA,
                        CDOPERCONT = :CDOPERCONT,
                        NRORG = :NRORG,
                        NRORGULTATU = :NRORGULTATU,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTULTATU = SYSDATE
                    WHERE NRSEQCONTATO = :NRSEQCONTATO";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirEvoContCda($parametros)
    {
        $sql = "INSERT INTO EVOLCONT (NRCONTATO, DTHREVOLCONT, CDTIPOCONT, CDPROSPECT, CDINTEPROS, CDCLIENTE, CDINTECLIE, IDSENEVOCONT, IDTPEVOLCONT, DSEVOLCONT, IDDESCPROT, CDFASECONT, IDAGEEVOCONT, CDOPEREVOL, NRSEQEVOLCON, CDMOTIEVOCON, DTHRINCLEVOCONT, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, NRRELACIONAPARC, IDANEXOEVOLCONT, TXEVOLCONT, IDATIVO, NRSEQEVOLCONT, NRSEQCONTATO, IDGERAFATURA, IDEVOLPUBLICO, IDRESPNOTA, IDEVOLINTERNA ) 
                VALUES (:NRCONTATO, SYSDATE, :CDTIPOCONT, :CDPROSPECT, :CDINTEPROS, :CDCLIENTE, :CDINTECLIE, :IDSENEVOCONT, :IDTPEVOLCONT, :DSEVOLCONT, :IDDESCPROT, :CDFASECONT, :IDAGEEVOCONT, :CDOPEREVOL, :NRSEQEVOLCON, :CDMOTIEVOCON, SYSDATE, :NRORG, SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :NRRELACIONAPARC, :IDANEXOEVOLCONT, :TXEVOLCONT, :IDATIVO, :NRSEQEVOLCONT, :NRSEQCONTATO, :IDGERAFATURA, :IDEVOLPUBLICO, :IDRESPNOTA, :IDEVOLINTERNA )";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarEvolContCda($parametros)
    {
        $sql = "UPDATE EVOLCONT
                    SET NRCONTATO = :NRCONTATO,
                        CDPROSPECT = :CDPROSPECT,
                        CDINTEPROS = :CDINTEPROS,
                        CDCLIENTE = :CDCLIENTE,
                        CDINTECLIE = :CDINTECLIE,
                        IDTPEVOLCONT = :IDTPEVOLCONT,
                        DSEVOLCONT = :DSEVOLCONT,
                        CDOPEREVOL = :CDOPEREVOL,
                        CDMOTIEVOCON = :CDMOTIEVOCON,
                        NRORG = :NRORG,
                        NRORGULTATU = :NRORGULTATU,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTULTATU = SYSDATE,
                        NRRELACIONAPARC = :NRRELACIONAPARC,
                        TXEVOLCONT = :TXEVOLCONT,
                        NRSEQCONTATO = :NRSEQCONTATO,
                        DTHRINCLEVOCONT = :DTHRINCLEVOCONT
                    WHERE NRSEQEVOLCONT = :NRSEQEVOLCONT";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirParticipantesCda($parametros)
    {
        $sql = "INSERT INTO SERVPRESTPARTICIP ( NRSERVPRESTPARTICIP, DSNOMEPARTICIP, DSSETORPARTICIP, CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, 
                            NRSERVPREST, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO) 
                    VALUES ( :NRSERVPRESTPARTICIP, :DSNOMEPARTICIP, :DSSETORPARTICIP, :CDEMPRESA, :CDFUNC, :CDCLIENTE, :DTSERVPREST, :NRSERVPREST, 
                            'S', :NRORG, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getParticipantesCda($parametros)
    {
        $sql = "SELECT NRSERVPRESTPARTICIP, DSNOMEPARTICIP, DSSETORPARTICIP
                    FROM SERVPRESTPARTICIP
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY')
                    AND NRSERVPREST = :NRSERVPREST";
                
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function atualizarParticipantes($parametros)
    {
        $sql = "UPDATE SERVPRESTPARTICIP 
                    SET DSNOMEPARTICIP = :DSNOMEPARTICIP, 
                        DSSETORPARTICIP = :DSSETORPARTICIP, 
                        CDEMPRESA = :CDEMPRESA, 
                        CDFUNC = :CDFUNC, 
                        CDCLIENTE = :CDCLIENTE, 
                        DTSERVPREST = :DTSERVPREST, 
                        NRSERVPREST = :NRSERVPREST, 
                        NRORG = :NRORG, 
                        DTULTATU = SYSDATE, 
                        NRORGULTATU = :NRORGULTATU, 
                        CDOPERULTATU = :CDOPERULTATU
                WHERE NRSERVPRESTPARTICIP = :NRSERVPRESTPARTICIP";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteParticipantes($parametros)
    {
        $sql = "DELETE FROM SERVPRESTPARTICIP WHERE NRSERVPRESTPARTICIP IN ($parametros)";

        $this->connection->executeStatement($sql);
    }

    public function verificarParticipanteJaInserido($parametros)
    {
        $sql = "SELECT COUNT(NRSERVPRESTPARTICIP) AS NRSERVPRESTPARTICIP
                    FROM SERVPRESTPARTICIP
                    WHERE NRSERVPRESTPARTICIP = :NRSERVPRESTPARTICIP";

        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $retorno[0]['NRSERVPRESTPARTICIP'];
    }

    public function getNrservcontAndNrseqageserv($parametros)
    {

        $sql = "SELECT AGE.NRSERVCONT, AGE.NRSEQAGESERV
                  FROM AGENDASERV AGE
                 WHERE AGE.NRPROPOSFAS  = :NRPROPOSFAS
                   AND AGE.NRVERPROPFAS = :NRVERPROPFAS
                   AND AGE.NRORG        = :NRORG
                   AND AGE.CDTIPOSERV   = :CDTIPOSERV
                   AND AGE.CDEMPRESA    = :CDEMPRESA
                   AND AGE.CDFUNC       = :CDFUNC
                   AND (TO_DATE(:DTSERVPREST, 'DD/MM/YYYY') BETWEEN AGE.DTINITRASERV AND AGE.DTFINTRASERV) 
                   AND ROWNUM = 1";
                
        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function inserirAtividadeCda($parametros)
    {
        $sql = "INSERT INTO SERVPREST (CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, NRSERVPREST, CDTIPOSERV, DSREFERENCIA, 
                CDINTECLIE, DTHRENTR1TUR, DTHRSAID1TUR, DTHRENTR2TUR,DTHRSAID2TUR, NMINTCLIENTE, NRPROPOSFAS, NRVERPROPFAS, 
                NRSEQAGESERV, NRSERVCONT,CDFILIAL, CDPROJETO, IDSITSERVPREST, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU,
                CDOPERULTATU, IDRESUAUDITCSA, CDPROSPECT, NRMOTIVOEXCEFREQ, IDSERVPREST, QTHRTOTAL, QTHRATIVIDADEFAT, 
                QTHRDESLOCAMENTOFAT, DTENTRADA, HRAUSENCIAALMOCO, DTSAIDA, NRCONTATO, DTHREVOLCONT, IDASSINATURACLIENTE, 
                IDORIGINALENTREGUE, IDATIVO, CDINTEPROS, NRSEQEVOLCONT, DTINCLUSAO, DTULTATU, DTHRENTR1FAT, DTHRSAID1FAT, DTHRENTR2FAT, DTHRSAID2FAT, NRLICENCAUSO, DSJUSTHRNAOFATURADA)
                
                VALUES (:CDEMPRESA, :CDFUNC, :CDCLIENTE, TO_DATE(:DTSERVPREST), :NRSERVPREST, :CDTIPOSERV, :DSREFERENCIA, :CDINTECLIE, 
                TO_DATE(:DTHRENTR1TUR), TO_DATE(:DTHRSAID1TUR), TO_DATE(:DTHRENTR2TUR), TO_DATE(:DTHRSAID2TUR), :NMINTCLIENTE, :NRPROPOSFAS, :NRVERPROPFAS, 
                :NRSEQAGESERV, :NRSERVCONT, :CDFILIAL, :CDPROJETO, :IDSITSERVPREST, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, 
                :NRORGULTATU, :CDOPERULTATU, 'NR', :CDPROSPECT, :NRMOTIVOEXCEFREQ, :IDSERVPREST, :QTHRTOTAL, :QTHRATIVIDADEFAT, 
                :QTHRDESLOCAMENTOFAT, TO_DATE(:DTENTRADA, 'DD/MM/YYYY HH24:MI'), :HRAUSENCIAALMOCO, TO_DATE(:DTSAIDA, 'DD/MM/YYYY HH24:MI'), :NRCONTATO, :DTHREVOLCONT, 
                'N', 'N', 'S', :CDINTEPROS, :NRSEQEVOLCONT, SYSDATE, SYSDATE, TO_DATE(:DTHRENTR1FAT), TO_DATE(:DTHRSAID1FAT), TO_DATE(:DTHRENTR2FAT), TO_DATE(:DTHRSAID2FAT), :NRLICENCAUSO, :DSJUSTHRNAOFATURADA)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarAtividadeCda($parametros)
    {
        $sql = "UPDATE SERVPREST
                    SET CDCLIENTE = :CDCLIENTE,
                        CDTIPOSERV = :CDTIPOSERV,
                        DSREFERENCIA = :DSREFERENCIA,
                        CDINTECLIE = :CDINTECLIE,
                        DTHRENTR1TUR = :DTHRENTR1TUR,
                        DTHRSAID1TUR = :DTHRSAID1TUR,
                        DTHRENTR2TUR = :DTHRENTR2TUR,
                        DTHRSAID2TUR = :DTHRSAID2TUR,
                        NMINTCLIENTE = :NMINTCLIENTE,
                        NRPROPOSFAS = :NRPROPOSFAS,
                        NRVERPROPFAS = :NRVERPROPFAS,
                        NRSEQAGESERV = :NRSEQAGESERV,
                        NRSERVCONT = :NRSERVCONT,
                        CDFILIAL = :CDFILIAL,
                        CDPROJETO = :CDPROJETO,
                        IDSITSERVPREST = :IDSITSERVPREST,
                        NRORG = :NRORG,
                        NRORGULTATU = :NRORGULTATU,
                        CDOPERULTATU = :CDOPERULTATU,
                        CDPROSPECT = :CDPROSPECT,
                        NRMOTIVOEXCEFREQ = :NRMOTIVOEXCEFREQ,
                        QTHRTOTAL = :QTHRTOTAL,
                        QTHRATIVIDADEFAT = :QTHRATIVIDADEFAT,
                        QTHRDESLOCAMENTOFAT = :QTHRDESLOCAMENTOFAT,
                        DTENTRADA = TO_DATE(:DTENTRADA, 'DD/MM/YYYY HH24:MI'),
                        HRAUSENCIAALMOCO = :HRAUSENCIAALMOCO,
                        DTSAIDA = TO_DATE(:DTSAIDA, 'DD/MM/YYYY HH24:MI'),
                        NRCONTATO = :NRCONTATO,
                        DTHREVOLCONT = :DTHREVOLCONT,
                        CDINTEPROS = :CDINTEPROS,
                        NRSEQEVOLCONT = :NRSEQEVOLCONT,
                        DTULTATU = SYSDATE,
                        DTHRENTR1FAT = TO_DATE(:DTHRENTR1FAT),
                        DTHRSAID1FAT = TO_DATE(:DTHRSAID1FAT), 
                        DTHRENTR2FAT = TO_DATE(:DTHRENTR2FAT), 
                        DTHRSAID2FAT = TO_DATE(:DTHRSAID2FAT),
                        NRLICENCAUSO = :NRLICENCAUSO
                WHERE IDSERVPREST = :IDSERVPREST
                AND NRSERVPREST = :NRSERVPREST
                AND CDEMPRESA = :CDEMPRESA
                AND CDFUNC = :CDFUNC
                AND DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY')";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function confirmaOuCorrigeCda($parametros)
    {
        $sql = "UPDATE SERVPREST
                    SET IDSITSERVPREST = :IDSITSERVPREST,
                        NRORGULTATU = :NRORGULTATU,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTULTATU = SYSDATE
                WHERE CDCLIENTE = :CDCLIENTE
                AND NRSERVPREST = :NRSERVPREST
                AND CDEMPRESA = :CDEMPRESA
                AND CDFUNC = :CDFUNC
                AND DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY')
                AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirDescricaoCDA($parametros)
    {
        $sql = "INSERT INTO DESCSERVPRES (CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, DSSERVPREST, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRSERVPREST, IDATIVO)
                VALUES (:CDEMPRESA, :CDFUNC, :CDCLIENTE, :DTSERVPREST, RAWTOHEX(:DSSERVPREST), :NRORG, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRSERVPREST, 'S')";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarDescricaoCDA($parametros)
    {
        $sql = "UPDATE DESCSERVPRES 
                    SET DSSERVPREST = RAWTOHEX(:DSSERVPREST),
                        DTULTATU =  SYSDATE, 
                        CDOPERULTATU = :CDOPERULTATU, 
                        NRORGULTATU = :NRORGULTATU
                WHERE CDEMPRESA = :CDEMPRESA 
                    AND CDFUNC = :CDFUNC 
                    AND CDCLIENTE = :CDCLIENTE 
                    AND DTSERVPREST = :DTSERVPREST 
                    AND NRSERVPREST = :NRSERVPREST 
                    AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getHorasNaoFaturadas($parametros)
    {
        $sql = "SELECT JUSTHORASNAOFATUCDA.NRJUSTHORASNAOFATUCDA, JUSTHORASNAOFATUCDA.DSJUSTHORASNAOFATUCDA, 
                    JUSTHORASNAOFATUCDA.TAGJUSTHORASNAOFATUCDA, SERVPRESTJUSTHRNFAT.QTHORASNAOFATU, SERVPRESTJUSTHRNFAT.NRSERVPRESTJUSTHRNFAT
                    FROM JUSTHORASNAOFATUCDA
                    LEFT JOIN SERVPRESTJUSTHRNFAT
                    ON SERVPRESTJUSTHRNFAT.NRJUSTHORASNAOFATUCDA = JUSTHORASNAOFATUCDA.NRJUSTHORASNAOFATUCDA
                    WHERE SERVPRESTJUSTHRNFAT.CDEMPRESA = :CDEMPRESA
                    AND SERVPRESTJUSTHRNFAT.CDFUNC = :CDFUNC
                    AND SERVPRESTJUSTHRNFAT.CDCLIENTE = :CDCLIENTE
                    AND SERVPRESTJUSTHRNFAT.DTSERVPREST = TO_DATE(:DTSERVPREST)
                    AND SERVPRESTJUSTHRNFAT.NRSERVPREST = :NRSERVPREST";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getProxNrHorasNaoFaturadas()
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(SP.NRSERVPRESTJUSTHRNFAT)), 0)+1, '00')) AS NRSERVPRESTJUSTHRNFAT
                    FROM SERVPRESTJUSTHRNFAT SP";
        
        $retorno = $this->connection->executeQuery($sql)->fetchAllAssociative();
        return $retorno[0]['NRSERVPRESTJUSTHRNFAT'];
    }

    public function inserirHorasNaoFaturadas($parametros)
    {
        $sql = "INSERT INTO SERVPRESTJUSTHRNFAT (NRSERVPRESTJUSTHRNFAT, CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, NRSERVPREST, NRJUSTHORASNAOFATUCDA, QTHORASNAOFATU, 
                            NRORG, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NRSERVPRESTJUSTHRNFAT, :CDEMPRESA, :CDFUNC, :CDCLIENTE, :DTSERVPREST, :NRSERVPREST, :NRJUSTHORASNAOFATUCDA, :QTHORASNAOFATU, :NRORG, 'S', 
                            SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarHorasNaoFaturadas($parametros)
    {
        $sql = "UPDATE SERVPRESTJUSTHRNFAT 
                    SET QTHORASNAOFATU = :QTHORASNAOFATU,
                        NRORG = :NRORG, 
                        DTULTATU =  SYSDATE, 
                        CDOPERULTATU = :CDOPERULTATU, 
                        NRORGULTATU = :NRORGULTATU
                    WHERE NRSERVPRESTJUSTHRNFAT = :NRSERVPRESTJUSTHRNFAT 
                    AND CDEMPRESA = :CDEMPRESA 
                    AND CDFUNC = :CDFUNC 
                    AND CDCLIENTE = :CDCLIENTE 
                    AND DTSERVPREST = :DTSERVPREST 
                    AND NRSERVPREST = :NRSERVPREST 
                    AND NRJUSTHORASNAOFATUCDA = :NRJUSTHORASNAOFATUCDA";
                    
        $this->connection->executeStatement($sql, $parametros);
    }

    public function getModeloDocumentoCda()
    {
        $sql = "SELECT NRMODELODOCCDA, DSMODELODOCORCA, IDDOCPADRAO 
                    FROM MODELODOCCDA
                    WHERE IDDOCPADRAO = 'S'";

        $retorno = $this->connection->executeQuery($sql)->fetchAllAssociative();
        if (count($retorno) > 0) {
            return $retorno[0]['NRMODELODOCCDA'];
        }
        return null;
    }

    public function inserirServPrestDoc($parametros)
    {
        $sql = "INSERT INTO SERVPRESTDOC(NRSERVPRESTDOC, CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, NRSERVPREST, NRMODELODOCCDA, NRORG, IDATIVO, 
                            DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NRSERVPRESTDOC, :CDEMPRESA, :CDFUNC, :CDCLIENTE, :DTSERVPREST, :NRSERVPREST, :NRMODELODOCCDA, :NRORG, 'S', SYSDATE, :CDOPERINCLUSAO, 
                        :NRORGINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function verificaModeloDocJaInserido($parametros)
    {
        $sql = "SELECT COUNT(NRSERVPRESTDOC) AS CONTADOR, NRSERVPRESTDOC
                    FROM SERVPRESTDOC
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = TO_DATE(:DTSERVPREST)
                    AND NRSERVPREST = :NRSERVPREST
                    GROUP BY NRSERVPRESTDOC";
        
        $retorno = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        if (count($retorno) > 0) {
            return $retorno[0];
        }
        return null;
    }

    public function alterarServPrestDoc($parametros)
    {
        $sql = "UPDATE SERVPRESTDOC
                SET CDCLIENTE = :CDCLIENTE,
                    DTSERVPREST = :DTSERVPREST, 
                    NRSERVPREST = :NRSERVPREST, 
                    NRMODELODOCCDA = :NRMODELODOCCDA, 
                    NRORG = :NRORG, 
                    DTULTATU = SYSDATE, 
                    CDOPERULTATU = :CDOPERULTATU, 
                    NRORGULTATU = :NRORGULTATU
                WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC
                AND CDEMPRESA = :CDEMPRESA
                AND CDFUNC = :CDFUNC
                AND DTSERVPREST = TO_DATE(:DTSERVPREST)
                AND NRSERVPREST = :NRSERVPREST";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function buscarDocumento()
    {
        $sql = "SELECT SERVPRESTDOC.NRMODELODOCCDA, MODELODOCCDAIDI.NMARQUIVO, MODELODOCCDAIDI.DSCAMINHOARQ, MODELODOCCDAIDI.DSTIPO
                    FROM SERVPRESTDOC
                    JOIN MODELODOCCDAIDI
                    ON MODELODOCCDAIDI.NRMODELODOCCDA = SERVPRESTDOC.NRMODELODOCCDA
                    WHERE SERVPRESTDOC.CDEMPRESA = :CDEMPRESA
                    AND SERVPRESTDOC.CDFUNC = :CDFUNC 
                    AND SERVPRESTDOC.CDCLIENTE = :CDCLIENTE 
                    AND SERVPRESTDOC.DTSERVPREST = TO_DATE(:DTSERVPREST) 
                    AND SERVPRESTDOC.NRSERVPREST = :NRSERVPREST
                    AND MODELODOCCDAIDI.CDIDIOM = :CDIDIOM";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function existenciaCda($parametros)
    {
        $sql = "SELECT COUNT(NRSERVPREST) AS EXISTE
                    FROM SERVPREST
                    WHERE NRORG IS NOT NULL
                    AND CDEMPRESA IS NOT NULL
                                    AND CDFUNC     IS NOT NULL
                                    AND CDCLIENTE   IS NOT NULL
                                    AND NRSERVPREST IS NOT NULL
                                    AND TO_CHAR(DTSERVPREST, 'DD/MM/YYYY') = :DTSERVPREST";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getDescricaoCda($parametros)
    {
        $sql = "SELECT SRV.NRORG, SRV.CDEMPRESA, SRV.CDFUNC, SRV.CDCLIENTE, SRV.DTSERVPREST, 
                    SRV.NRSERVPREST, DSP.DSSERVPREST, DSP.NRSERVPREST AS NRSERVPRESTDESC
                    FROM SERVPREST SRV, DESCSERVPRES DSP
                    WHERE (SRV.NRORG = :NRORG)
                    AND (SRV.CDEMPRESA = :CDEMPRESA)
                    AND (SRV.CDFUNC = :CDFUNC)
                    AND (SRV.CDCLIENTE = :CDCLIENTE)
                    AND (SRV.DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY'))
                    AND (SRV.NRSERVPREST = :NRSERVPREST)
                    AND (SRV.NRORG = DSP.NRORG(+))
                    AND (SRV.CDEMPRESA = DSP.CDEMPRESA(+))
                    AND (SRV.CDFUNC = DSP.CDFUNC(+))
                    AND (SRV.CDCLIENTE = DSP.CDCLIENTE(+))
                    AND (SRV.DTSERVPREST = DSP.DTSERVPREST(+))
                    AND (SRV.NRSERVPREST = DSP.NRSERVPREST(+))";
        
        return $this->connection->executeQuery($sql, $parametros)->fetchAll();
    }

    public function deleteBatidaPonto($parametros)
    {
        $sql = "DELETE FROM BATIDAPONTO
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = :DTSERVPREST
                    AND NRSERVPREST = :NRSERVPREST";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteDescServPrest($parametros)
    {
        $sql = "DELETE FROM DESCSERVPRES
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = :DTSERVPREST
                    AND NRSERVPREST = :NRSERVPREST";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteServPrestDoc($parametros)
    {
        $sql = "DELETE FROM SERVPRESTDOC
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = :DTSERVPREST
                    AND NRSERVPREST = :NRSERVPREST";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteServPrest($parametros)
    {
        $sql = "DELETE FROM SERVPREST
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND CDFUNC = :CDFUNC
                    AND CDCLIENTE = :CDCLIENTE
                    AND DTSERVPREST = :DTSERVPREST
                    AND NRSERVPREST = :NRSERVPREST";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteHorasNaoFaturadas($parametros)
    {
        $sql = "DELETE FROM SERVPRESTJUSTHRNFAT WHERE NRSERVPRESTJUSTHRNFAT IN ($parametros)";
    
        $this->connection->executeStatement($sql);
    }

    public function deleteEvolCont($parametros)
    {
        $sql = "DELETE FROM EVOLCONT 
                    WHERE NRSEQEVOLCONT = :NRSEQEVOLCONT
                    AND NRCONTATO = :NRCONTATO
                    AND DTHREVOLCONT = :DTHREVOLCONT";
    
        $this->connection->executeStatement($sql, $parametros);
    }
    
}
