/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VIAD                                                     */
/* Tabela : VIACESDIET                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 08/01/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_VIAD
BEFORE INSERT OR UPDATE OR DELETE
ON VIACESDIET FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUVIAD := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDVIACESDIET,0) <> NVL(:NEW.CDVIACESDIET,0)) OR
         (NVL(:OLD.NMVIACESDIET,0) <> NVL(:NEW.NMVIACESDIET,0)) THEN
         :NEW.DTULTATUVIAD := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('VIACESDIET', '', 'CDVIACESDIET='||:OLD.CDVIACESDIET||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE VIACESDIET MODIFY DTULTATUVIAD DEFAULT SYSDATE
/
