/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_UNIDMED                                                  */
/* Tabela : UNIDMEDIDA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_UNIDMED
BEFORE INSERT OR UPDATE OR DELETE
ON UNIDMEDIDA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUUNID := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUUNID := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('UNIDMEDIDA', '', 'SGUNIDADE='||:OLD.SGUNIDADE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE UNIDMEDIDA MODIFY DTULTATUUNID DEFAULT SYSDATE
/

UPDATE UNIDMEDIDA SET DTULTATUUNID = SYSDATE WHERE DTULTATUUNID IS NULL
/

